function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

var Storage = /*#__PURE__*/function () {
  function Storage(namespace) {
    _classCallCheck(this, Storage);

    this.storage = browser.storage.local;
    this.namespace = namespace;
  }

  _createClass(Storage, [{
    key: "get",
    value: function get(key) {
      var _this = this;

      return this.storage.get(this.namespace).then(function (data) {
        data = data[_this.namespace] || {};
        return data[key];
      });
    }
  }, {
    key: "set",
    value: function set(key, value) {
      var _this2 = this;

      return this.storage.get(this.namespace).then(function (data) {
        data = data[_this2.namespace] || {};
        data[key] = value;
        return _this2.storage.set(_defineProperty({}, _this2.namespace, data));
      });
    }
  }, {
    key: "remove",
    value: function remove(key) {
      return this.set(key, '');
    }
  }]);

  return Storage;
}();

var HttpError = /*#__PURE__*/function (_Error) {
  _inherits(HttpError, _Error);

  var _super = _createSuper(HttpError);

  function HttpError(status, error) {
    var _this;

    _classCallCheck(this, HttpError);

    _this = _super.call(this);

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this), HttpError);
    }

    _this.status = status;
    _this.error = error;
    return _this;
  }

  return HttpError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

var enhancedFetch = (function (url, request) {
  return fetch(url, request).then(function (res) {
    if (res.ok) {
      return res.json();
    }

    return res.text().then(function (body) {
      var err;

      try {
        err = JSON.parse(body);
      } catch (e) {
        err = body;
      }

      throw new HttpError(res.status, err);
    });
  });
});

var generateRandomString = (function () {
  var array = new Uint32Array(28);
  window.crypto.getRandomValues(array);
  return Array.from(array, function (dec) {
    return ('0' + dec.toString(16)).substr(-2);
  }).join('');
});

var getParamsFromCallbackUrl = (function (url) {
  var parsedUrl = new URL(url);
  return parsedUrl.hash.substring(1).split('&').reduce(function (params, part) {
    var parts = part.split('=');
    params[parts[0]] = parts[1];
    return params;
  }, {});
});

var getRedirectUrl = (function (provider) {
  return "".concat(browser.identity.getRedirectURL()).concat(provider);
});

var ACESS_TOKEN_KEY = 'accessToken';

var Oauth2 = /*#__PURE__*/function () {
  function Oauth2(config) {
    _classCallCheck(this, Oauth2);

    this.provider = config.provider;
    this.storage = new Storage(this.provider);
    this.authorizationEndpoint = config.authorization_endpoint;
    this.responseType = 'token';
    this.clientId = config.client_id;
    this.scopes = config.scopes;
    this.apiBaseUrl = config.api_base_url;
  }

  _createClass(Oauth2, [{
    key: "promptErrorHandler",
    value: function promptErrorHandler(err) {
      var error;

      if (typeof err === 'string') {
        var params = getParamsFromCallbackUrl(error);
        error = new Error(params.error);
      } else {
        error = err;
      }

      throw error;
    }
  }, {
    key: "getAccessTokenImplict",
    value: function getAccessTokenImplict() {
      var _this = this;

      var state = generateRandomString();
      var url = this.authorizationEndpoint;
      url += "?response_type=".concat(this.responseType);
      url += "&scope=".concat(encodeURIComponent(this.scopes.join(' ')));
      url += "&client_id=".concat(this.clientId);
      url += "&redirect_uri=".concat(encodeURIComponent(getRedirectUrl(this.provider)));
      url += "&state=".concat(state);
      return browser.identity.launchWebAuthFlow({
        interactive: true,
        url: url
      }).then(function (url) {
        var params = getParamsFromCallbackUrl(url);
        var accessToken = params.access_token;

        if (params.state !== state) {
          throw new Error('Invalid state.');
        }

        return _this.storage.set(ACESS_TOKEN_KEY, accessToken).then(function () {
          return accessToken;
        });
      })["catch"](this.promptErrorHandler);
    }
  }, {
    key: "getAccessToken",
    value: function getAccessToken() {
      var _this2 = this;

      return this.storage.get(ACESS_TOKEN_KEY).then(function (accessToken) {
        if (accessToken) {
          return accessToken;
        }

        return _this2.getAccessTokenImplict();
      });
    }
  }, {
    key: "callApi",
    value: function callApi(path) {
      var _this3 = this;

      var request = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var url = this.apiBaseUrl ? "".concat(this.apiBaseUrl).concat(path) : path;
      return this.getAccessToken().then(function (token) {
        request.headers = request.headers || {};
        request.headers = _objectSpread2(_objectSpread2({}, request.headers), {}, {
          Authorization: "Bearer ".concat(token)
        });
        return enhancedFetch(url, request);
      })["catch"](function (error) {
        if (error.status === 401) {
          return _this3.storage.remove(ACESS_TOKEN_KEY).then(function () {
            return _this3.callApi(path, request);
          });
        }

        throw error.error;
      });
    }
  }]);

  return Oauth2;
}();

export default Oauth2;
export { HttpError, Storage, enhancedFetch };
//# sourceMappingURL=index.es.js.map
